---
- name: determine if docker is installed
  command: which docker
  register: docker_installed
  ignore_errors: true
  changed_when: false

- name: get docker version
  shell: docker --version | awk '{ print $3 }'
  register: docker_installed_version
  when: docker_installed is success
  changed_when: false

- name: unpin docker version if upgrading
  dpkg_selections:
    name: "{{'docker-engine' if docker_installed_version.stdout is search('1.12') else 'docker-ce' }}"
    selection: install
  when: docker_installed is success and docker_installed_version.stdout is not search(docker_version|string)

- name: install or upgrade docker
  shell: curl https://releases.rancher.com/install-docker/{{ docker_version }}.sh | sh
  args:
    warn: no
  when: docker_installed is not success or
        docker_installed_version.stdout is not search(docker_version|string)

- name: get docker version (again)
  shell: docker --version | awk '{ print $3 }'
  register: docker_installed_version
  changed_when: false

- name: pin docker version
  dpkg_selections:
    name: "{{'docker-engine' if docker_installed_version.stdout is search('1.12') else 'docker-ce' }}"
    selection: hold

- name: upgrade pip (Ubuntu)
  pip:
    name: pip
    state: latest
  when: ansible_os_family == "Debian" and not ansible_distribution == "Debian" and ansible_distribution_version != '18.04'
  tags: pip

- name: install additional dependencies (pip)
  pip:
    name: docker-py
    state: present
  tags: pip

- name: add our login user to docker group
  user:
    name: "{{ansible_user}}"
    groups: docker
    append: yes
  when: ansible_user != 'root'

- name: install daemon.json
  template:
    src: daemon.json.j2
    dest: /etc/docker/daemon.json
  notify: restart docker
  tags: docker:config

- name: make sure docker is running
  service:
    name: docker
    state: started
    enabled: yes
